# EPZ 1.0
# DATA object to send data generated by a specific device
# one record in data is [x,y,z,save,overload]

import zmq
from .epz import epzobject

class DATA(epzobject):
    def setZMQ(self):
        self._socket = self.context.socket(zmq.PUB)
        self._socket.connect("tcp://{0}:{1}".format(self.epserver, self.pubport))

    def send(self, x,y,z,save=0,overload=0):
        msg = '{0}:{1}:{2}:{3}:{4}:{5}:{6}'.format(self.device, self.tag,x,y,z,save,overload)
        self._socket.send_string(msg)